using System.Collections.Generic;
using MoonTools.ECS.Collections;

namespace MoonTools.ECS;

internal class Archetype
{
	public World World;
	public ArchetypeSignature Signature;
	public NativeArray<Entity> Entities = new NativeArray<Entity>();

	public SortedDictionary<TypeId, ArchetypeEdge> Edges = new SortedDictionary<TypeId, ArchetypeEdge>();

	public int Count => Entities.Count;

	public Archetype(World world, ArchetypeSignature signature)
	{
		World = world;
		Signature = signature;
	}

	public int Append(Entity entity)
	{
		Entities.Append(entity);
		return Entities.Count - 1;
	}

	public int Transfer(int row, Archetype transferTo)
	{
		var newIndex = transferTo.Append(Entities[row]);
		Entities.Delete(row);
		return newIndex;
	}

	public void ClearAll()
	{
		for (int i = Entities.Count - 1; i >= 0; i -= 1)
		{
			World.Destroy(Entities[i]);
		}
	}
}
